import { IBootBuilder } from './IBootBuilder';
import { Token, IContainer } from '@ts-ioc/core';
import { ModuleConfigure } from './ModuleConfigure';
/**
 * token bootstrap builder. build class with metadata and config.
 *
 * @export
 * @class BootBuilder
 * @implements {implements IBootBuilder<T>}
 * @template T
 */
export declare class BootBuilder<T> implements IBootBuilder<T> {
    container: IContainer;
    constructor(container: IContainer);
    build(token: Token<T>, config: ModuleConfigure, data?: any): Promise<T>;
    buildByConfig(config: Token<T> | ModuleConfigure, data?: any): Promise<any>;
    createInstance(token: Token<T>, config: ModuleConfigure, data?: any): Promise<T>;
    /**
     * bundle instance via config.
     *
     * @param {T} instance
     * @param {ModuleConfigure} config
     * @param {IContainer} [container]
     * @returns {Promise<T>}
     * @memberof BootBuilder
     */
    buildStrategy(instance: T, config: ModuleConfigure): Promise<T>;
    getBootstrapToken(config: ModuleConfigure): Token<T>;
    protected resolveToken(token: Token<T>, data?: any): T;
    protected getBuilderViaConfig(builder: Token<IBootBuilder<T>> | IBootBuilder<T>, container: IContainer): IBootBuilder<T>;
    static classAnnations: any;
}
