"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var IApplicationBuilder_1 = require("../IApplicationBuilder");
var DIModule_1 = require("./DIModule");
/**
 * create bootstrap decorator.
 *
 * @export
 * @template T
 * @param {string} decorType
 * @param {(Token<IApplicationBuilder> | IApplicationBuilder)} [builder]
 * @param {(Token<IBootBuilder<any>> | IBootBuilder<Tany>)} [moduleBuilder]
 * @param {(Token<IBootBuilder<any>> | IBootBuilder<Tany>)} [bootstrapBuilder]
 * @param {InjectToken<IApplication>} provideType default provide type.
 * @param {MetadataAdapter} [adapter]
 * @param {MetadataExtends<T>} [metadataExtends]
 * @returns {IBootstrapDecorator<T>}
 */
function createBootstrapDecorator(decorType, builder, moduleBuilder, bootstrapBuilder, provideType, adapter, metadataExtends) {
    return DIModule_1.createDIModuleDecorator(decorType, builder, moduleBuilder, bootstrapBuilder, provideType, adapter, metadataExtends);
}
exports.createBootstrapDecorator = createBootstrapDecorator;
/**
 * Bootstrap Decorator, definde class as mvc bootstrap module.
 *
 * @Bootstrap
 */
exports.Bootstrap = createBootstrapDecorator('bootstrap', IApplicationBuilder_1.ApplicationBuilderToken);

//# sourceMappingURL=../sourcemaps/decorators/Bootstrap.js.map
